<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006 Artur Wiebe                                        *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   Released under the terms & conditions of v2 of the                    *
 *   GNU General Public License. For details refer to                      *
 *   the included gpl.txt file or visit http://gnu.org                     *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once BASEDIR."side_left.php";
require_once("include/common.php");
if(iPDP_EDIT) {
	fallback("download.php?did=$pdp_did");
}
require_once("include/edit.php");



?>
<script type='text/javascript'>
function verify_form(frm) {
	if(frm.version.value==""
		|| (frm.save_ftp.value=="" && frm.url.value=="" && frm.upload.value=="")) {
		alert("<?php echo $locale['PDP011']; ?>");
		return false;
	}
	return true;
}
</script>
<?php


/*
 * Action
 */
$need_redir = false;
$next_step = false;

$log = false;
$log_event = PDP_EV_INVALID;
$log_errno = 0;

if(isset($_POST['save'])) {	// FIXME
	$size = stripinput($_POST['size']);
	$url = "";

	if(isset($_GET['file_id']) && isNum($_GET['file_id'])) {
		$file_id = $_GET['file_id'];
	} else {
		unset($file_id);
	}

/*FIXME
	echo "<pre>\n";
	print_r($_POST);
	echo "</pre>\n";
*/

	// try FTP first
	if(isset($_POST['save_ftp']) && !empty($_POST['save_ftp'])) {
		$log_event = PDP_EV_FILEFTP;
		if(!iPDP_ADMIN) {
			pdp_log_event($log_event, PDP_EACCESS);
			fallback(FUSION_SELF."?did=$pdp_did"
				."&errno=".PDP_EACCESS);
		}
		$url = stripinput($_POST['save_ftp']);
		if(empty($size)) {
			$size = parsebytesize(filesize($pdp_settings['upload_file'].$url));
		}
	// try URL second
	} elseif(isset($_POST['url']) && !empty($_POST['url'])) {
		$log_event = PDP_EV_FILEURL;
		$url = stripinput($_POST['url']);
		if(!iPDP_ADMIN && !pdp_is_external($url)) {
			pdp_log_event($log_event, PDP_EURL);
			fallback(FUSION_SELF."?did=$pdp_did"
				."&errno=".PDP_EURL);
		}
	// try UPLOAD last
	} elseif(isset($_FILES['upload'])
		&& $_FILES['upload']['error']!=UPLOAD_ERR_NO_FILE) {

		$log_event = PDP_EV_FILEUPLOAD;

		// cannot be updated.
		if(isset($file_id)) {
			pdp_log_event($log_event, PDP_EACCESS);
			fallback(FUSION_SELF."?did=$pdp_did"
				."&errno=".PDP_EACCESS);
		}

		$ext = explode(",", $pdp_settings['file_ext']);
		foreach($ext as $key => $val) {
			$ext[$key] = ".".$val;
		}

		$errno = pdp_upload_file($_FILES['upload'],
			$pdp_settings['upload_file'],
			$pdp_settings['file_max'], $ext, $url);
		if($errno) {
			pdp_log_event($log_event, $errno);
			fallback(FUSION_SELF."?did=$did&errno=$errno");
		}
		if(empty($size)) {
			$size = parsebytesize(filesize($pdp_settings['upload_file'].$url));
		}
	}

	$ver = stripinput($_POST['version']);
	$desc = stripinput($_POST['desc']);
	$now = time();
	if(empty($url)) {
		$url = "file_url";
	} else {
		$url = "'$url'";
	}
/*
	echo "<p><b>+ $url</b>\n";
	echo "<p><b>+ $size</b>\n";
*/

	// new
	if(!isset($file_id)) {
		$ok = dbquery("INSERT INTO ".DB_PREFIX."pdp_files"
			." SET dl_id='$pdp_did'");
		$file_id = mysql_insert_id();
	} else {
		$file_id = stripinput($_GET['file_id']);
	}

	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_files"
		." SET file_version='$ver',"
		." file_size='$size',"
		." file_desc='$desc',"
		." file_url=$url,"	// XXX - no '', cause can be a column
		." file_timestamp='$now'"
		." WHERE file_id='$file_id' AND dl_id='$pdp_did'");
	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
		." SET dl_mtime='$now'"
		." WHERE dl_id='$pdp_did'");

	$log = true;
	$log_errno = 0;
	$need_redir = true;

// FIMXE: COMPATIBILITY
} elseif(isset($_GET['clear'])) { //FIXME
	$field = "";
	switch($_GET['clear']) {
	case "down":	$field = "down";	break;
	case "extern":	$field = "link_extern";	break;
	case "version":	$field = "version";	break;
	case "size":	$field = "dl_size";	break;
	}
	if(!empty($field)) {
		dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
			." SET $field=''"
			." WHERE dl_id='$pdp_did'");
	}
	$need_redir = true;


} elseif(isset($_GET['del']) && isNum($_GET['del'])) {
	$log_event = PDP_EV_DELFILE;

	$fid = $_GET['del'];
	$query_id = dbquery("SELECT file_url"
		." FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='$fid' AND dl_id='$pdp_did'");
	if(!dbrows($query_id)) {
		pdp_log_event($log_event, PDP_EFILE);
		fallback(FUSION_SELF."?did=$pdp_did"
			."&errno=".PDP_EFILE);
	}
	$url = array_shift(dbarray($query_id));
	$ok = false;


	// confirm
	if(!pdp_is_external($url)) {
		opentable($locale['PDP008']);
		$href = FUSION_SELF."?did=$pdp_did&amp;del=$fid";
		echo "<table border='0' align='center' width='400px'>\n"
		."<tr>\n"
			."<td colspan='2' align='center'>"
				.$locale['PDP130']."<br>"
				."<b>".pdp_cleanup_filename($url)."</b>"
				."</td>"
		."</tr>\n"
		."<tr>\n"
			."<td align='center' width='50%'>"
				."<a href='$href&amp;with_file=1'"
				." onClick='return confirm_delete();'>"
				.$locale['PDP131']."</a></td>\n"
			."<td align='center' width='50%'>"
				."<a href='$href&amp;with_file=0'>"
				.$locale['PDP132']."</a></td>\n"
		."</tr>\n"
		."</table>\n";
		closetable();
		tablebreak();
	}

	// delete db-entry and file
	if(pdp_is_external($url) || isset($_GET['with_file'])) {
		if(isset($_GET['with_file']) && $_GET['with_file']=="1") {
			$ok = unlink($pdp_settings['upload_file'].$url);
		}
		$ok = dbquery("DELETE FROM ".DB_PREFIX."pdp_files"
			." WHERE file_id='$fid' AND dl_id='$pdp_did'");

		$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
			." SET dl_mtime='$now'"
			." WHERE dl_id='$pdp_did'");
	}

	if($ok) {
		$need_redir = true;
	}
	$log_errno = 0;
	$log = true;
}


if($log) {
	pdp_log_event($log_event, $log_errno);
}


if($need_redir) {
	$ok = true;

	if(!iPDP_ADMIN) {
		$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
			." SET dl_status='".PDP_PRO_OFF."'"
			." WHERE dl_id='$pdp_did'"
			." AND dl_status='".PDP_PRO_ON."'");
	}

	if($ok) {
		if($next_step) {
			fallback("edit_pics.php?did=$did&step=3");
		}
		fallback(FUSION_SELF."?did=$pdp_did");
	}
}


/*
 * GUI - errno
 */
if(isset($_GET['errno'])) {
	pdp_process_errno($_GET['errno']);
}


/*
 * GUI
 */
if(!is_writeable($pdp_settings['upload_file'])) {
	pdp_msg(false, str_replace("%s",
		"<b>".$pdp_settings['upload_file']."</b>",
		$locale['PDP900'][PDP_EUPDIR]));
}


$action = FUSION_SELF."?did=$did";

if($pdp_dl['dl_status']==PDP_PRO_NEW) {
	pdp_upload_step(3, "upload_done.php", $pdp_did);
}


/*
 * GUI
 */
opentable($locale['PDP019']);
echo $pdp_edit_menu;


// files table
$query_id = dbquery("SELECT *"
	." FROM ".DB_PREFIX."pdp_files AS ff"
	." WHERE dl_id='$did' ORDER BY file_timestamp DESC");
if(!dbrows($query_id)) {
	echo "<p>".$locale['PDP120'];
} else {
	echo "<table class='tbl-border' width='100%' cellspacing='1'>
<tr>
	<td class='tbl2' width='16'></td>
	<td class='tbl2' width='16'></td>
	<td class='tbl2'><b>".$locale['PDP018']."</b>"
		." [<a href='".FUSION_SELF."?did=$did'>".$locale['PDP003']
		."</a>]</td>
	<td class='tbl2'><b>".$locale['PDP025']."</b></td>
	<td class='tbl2'><b>".$locale['PDP013']."</b></td>
	<td class='tbl2'><b>".$locale['PDP129']."</b></td>
	<td class='tbl2'><b>".$locale['PDP029']."</b></td>
	<td class='tbl2' width='16'></td>
</tr>\n";
}

$count = 0;
$tbl = "class='tbl1'";
while($file = dbarray($query_id)) {
	$fid = $file['file_id'];

	if(pdp_is_external($file['file_url'])) {
		$dl_icon = "external.gif";
		$dl_link = $file['file_url'];
	} else {
		$dl_link = $pdp_settings['upload_file'].$file['file_url'];
		if(file_exists($dl_link)) {
			$dl_icon = "download.gif";
			$dl_link = "";//FIXME
		} else {
			$ex_icon = "nofile.gif";
			$dl_link = "";
		}
	}

	echo "<tr>
	<td $tbl><a href='$dl_link' target='_blank'><img src='icons/$dl_icon'"
		." alt='' border='0'></a></td>
	<td $tbl><a href='".FUSION_SELF."?did=$did&amp;edit=$fid'>"
		."<img src='icons/edit.gif' border='0'"
			." alt='".$locale['PDP007']."'></a></td>
	<td $tbl>".$file['file_version']."</td>
	<td $tbl>".$file['file_desc']."</td>
	<td $tbl>".showdate("shortdate", $file['file_timestamp'])."</td>
	<td $tbl>".pdp_cleanup_filename($file['file_url'])."</td>
	<td $tbl>".$file['file_size']."</td>
	<td $tbl><a href='".FUSION_SELF."?did=$did&amp;del=$fid'"
		." onClick='return confirm_delete();'>"
		."<img src='icons/delete.gif' alt='' border='0'></a></td>
</tr>\n";
//	echo "<tr><td class='tbl1'></td><td class='tbl1' colspan='5'>".$file['file_url']."</td></tr>\n";
	$tbl = "class='tbl".(++$count%2+1)."'";
}
if(dbrows($query_id)) {
	echo "</table>
<table border='0'>
<tr>
	<td><img src='icons/nofile.gif' alt=''></td>
	<td>".$locale['PDP046']."</td>
</tr>
<tr>
	<td><img src='icons/download.gif' alt=''></td>
	<td>".$locale['PDP218']."</td>
</tr>
<tr>
	<td><img src='icons/external.gif' alt=''></td>
	<td>".$locale['PDP127']."</td>
</tr>
</table>\n";
}
closetable();
tablebreak();


/*
 * FIXME: COMPATIBILITY CODE
 */
if(!empty($pdp_dl['down']) || !empty($pdp_dl['link_extern'])
	|| !empty($pdp_dl['version']) || !empty($pdp_dl['dl_size'])) {
	opentable($locale['PDP027']);
	echo "<p>".$locale['PDP123'];

	echo "<p><b>".$locale['PDP125'].":</b> ".$pdp_dl['down'];
	if(!empty($pdp_dl['down'])) {
		echo " [ <a href='".FUSION_SELF."?did=$did&clear=down'>"
			.$locale['PDP126']."</a> ]";
	}

	echo "<p><b>".$locale['PDP127'].":</b> ".$pdp_dl['link_extern'];
	if(!empty($pdp_dl['link_extern'])) {
		echo " [ <a href='".FUSION_SELF."?did=$did&clear=extern'>"
			.$locale['PDP126']."</a> ]";
	}

	echo "<p><b>".$locale['PDP018'].":</b> ".$pdp_dl['version'];
	if(!empty($pdp_dl['version'])) {
		echo " [ <a href='".FUSION_SELF."?did=$did&clear=version'>"
			.$locale['PDP126']."</a> ]";
	}

	echo "<p><b>".$locale['PDP029'].":</b> ".$pdp_dl['dl_size'];
	if(!empty($pdp_dl['dl_size'])) {
		echo " [ <a href='".FUSION_SELF."?did=$did&clear=size'>"
			.$locale['PDP126']."</a> ]";
	}
	
	closetable();
	tablebreak();
}


/*
 * EDIT FORM
 */
opentable($locale['PDP128']);

// form itself
$ver = "";
$desc = "";
$size = "";
$url = "";
$action = FUSION_SELF."?did=$pdp_did";
$do_edit = false;

if(isset($_GET['edit']) && isNum($_GET['edit'])) {
	$query_id = dbquery("SELECT * FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='".$_GET['edit']."' AND dl_id='$pdp_did'");
	if(!dbrows($query_id)) {
		fallback($action);
	}
	$data = dbarray($query_id);
	$url = $data['file_url'];
	$ver = $data['file_version'];
	$desc = $data['file_desc'];
	$size = $data['file_size'];

	$action = FUSION_SELF."?did=$pdp_did&file_id=".$_GET['edit'];
	$do_edit = true;
}

// ftp files
if(iPDP_ADMIN) {
	$files = array();
	$handle = opendir($pdp_settings['upload_file']);
	while(false !== ($file=readdir($handle))) {
		if(in_array($file, array(".", "..", "/", "index.php"))) {
			continue;
		}
		if(!is_dir($pdp_settings['upload_file'].$file)) {
			$files[$file] = filesize($pdp_settings['upload_file'].$file);
		}
	}
	closedir($handle);
	ksort($files);

	$sel_ftp = "<option value=''>".$locale['PDP033']."</option>\n";
	$last_group = "";
	foreach($files as $file => $filesize) {
		if($last_group != strtoupper(substr($file, 0, 1))) {
			if(!empty($last_group)) {
				$sel_ftp .= "</optgroup>\n";
			}
			$last_group = strtoupper(substr($file, 0, 1));
			$sel_ftp .= "<optgroup label='$last_group'>\n";
		}
		$sel_ftp .= "<option";
		if($url==$file) {
			$sel_ftp .= " selected";
			$url = "";
		}
		$sel_ftp .= " value='$file'>$file (".parsebytesize($filesize)
			.")</option>\n";
	}
	$sel_ftp .= "</optgroup>\n";


	// OTHERS
	$src_url = "<tr>
	<td width='1%'>".$locale['PDP217'].":</td>
	<td><input type='text' class='textbox' name='url'"
		." value='$url' maxlegth='200' style='width:100%;'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP216']."</span></td>
</tr>\n";

	$src_ftp = "<tr>
	<td>".$locale['PDP218'].":</td>
	<td><select size='1' name='save_ftp' class='textbox'>".$sel_ftp
		."</select></td>
</tr>
<tr>
	<td></td><td><b>".$locale['PDP133']."</b></td>
</tr>\n";
} else {
	$src_ftp = "";

	$src_url = "<tr>
	<td width='1%'>".$locale['PDP217'].":</td>
	<td><input type='text' class='textbox' name='url'"
		." value='$url' maxlegth='200' style='width:100%;'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP220']."</span></td>
</tr>\n";
}
if($do_edit) {
	$src_upload = "";
} else {
	$src_upload = "<tr>
	<td></td><td><b>".$locale['PDP133']."</b></td>
</tr>
<tr>
	<td>".$locale['PDP219'].":</td>
	<td><input type='file' class='textbox' name='upload' size='50'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP034'].": "
		.parsebytesize($pdp_settings['file_max'])
		." (".str_replace(",", ", ", $pdp_settings['file_ext'])
		.")</span></td>
</tr>\n";
}


// determine what to show and why
$src_read_only = "";
if($do_edit) {
	$is_external = pdp_is_external($url);
	if(iPDP_ADMIN) {
	} else {
		$src_ftp = "";
		if(!$is_external) {
			$src_url = "";
			$src_read_only = "<tr><td><b>"
				.pdp_cleanup_filename($url)."</b></td></tr>\n";
		}
	}
} else {
	if(iPDP_ADMIN) {
	} else {
	}
}


echo "<form action='$action' method='post' name='editform'"
	." onSubmit='return verify_form(this);' enctype='multipart/form-data'>
<table class='tbl-border' width='100%' cellspacing='1'>
<tr>
	<td class='tbl2' valign='top' width='150'>".$locale['PDP129'].": *</td>
	<td class='tbl1'>
<!--DOWNLOAD-SOURCE-BEGIN-->
<table border='0' width='100%'>
$src_read_only
$src_ftp
$src_url
$src_upload
</table>
<!--DOWNLOAD-SOURCE-END-->
	</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP018'].": *</td>
	<td class='tbl1'><input type='text' class='textbox' name='version'"
		." value='$ver' maxlegth='20' size='20'></td>
</tr>
<tr>
	<td class='tbl2' valign='top'>".$locale['PDP029'].":</td>
	<td class='tbl1'><input type='text' class='textbox' name='size'"
		." value='$size' maxlegth='20' size='20'><br>"
		."<span class='small2'>".$locale['PDP221']."</span></td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP025'].":</td>
	<td class='tbl1'><input type='text' class='textbox' name='desc'"
		." value='$desc' maxlegth='100' size='60'></td>
</tr>
<tr>
	<td colspan='2' align='center' class='tbl2'><input type='submit'"
		." class='button' name='save' value='".$locale['PDP010']."'></td>
</tr>
</table>
</form>\n";

closetable();


require_once BASEDIR."side_right.php";
require_once(BASEDIR."footer.php");
?>
