<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006 Artur Wiebe                                        *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   Released under the terms & conditions of v2 of the                    *
 *   GNU General Public License. For details refer to                      *
 *   the included gpl.txt file or visit http://gnu.org                     *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");
require_once("include/common.php");
if(!pdp_check_access($pdp_settings['uploadbereich'])) {
	fallback("download.php");
}
if(isset($pdp_did) && !iPDP_EDIT) {
	fallback("download.php?did=$did");
}
require_once("include/edit.php");


?>
<script type="text/javascript">
function verify(frm) {
	if(frm.name.value=="" || frm.cat.value=="0") {
		alert("<?php echo $locale['PDP011'] ?>");
		return false;
	}
	return true;
}

</script>
<?php



/*
 * Action!
 */
if(isset($_POST['save'])) {
	$cat = stripinput($_POST['cat']);
	if(!$cat) {
		fallback(FUSION_SELF);
	}
	$name = trim(stripinput($_POST['name']));
	if(empty($name)) {
		fallback(FUSION_SELF);
	}
	$homepage = stripinput($_POST['homepage']);
	$beschreibung = stripinput($_POST['desc']);
	$copyright = stripinput($_POST['copyright']);
	$license_id = stripinput($_POST['license_id']);
	$lizenz_okay = isset($_POST['lizenz_okay']) ? "Y" : "N";
	$lizenz_packet = isset($_POST['lizenz_packet']) ? "Y" : "N";
	$lizenz_url = stripinput($_POST['lizenz_url']);
	$now = time();

	if(!isset($did)) {
		$ok = dbquery("INSERT INTO ".DB_PREFIX."pdp_downloads"
			." SET dl_count='0',"
			." user_id='".$userdata['user_id']."',"
			." dl_ctime='$now',"
			." dl_status='".PDP_PRO_NEW."'");
		$pdp_did = mysql_insert_id();
		$pdp_dl['dl_status'] = PDP_PRO_NEW;
	}

	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
		." SET"
		." cat_id='$cat', dl_name='$name',"
		." dl_desc='$beschreibung',"
		." dl_copyright='$copyright',"
		." license_id='$license_id',"
		." lizenz_okay='$lizenz_okay',"
		." lizenz_packet='$lizenz_packet',"
		." lizenz_url='$lizenz_url',"
		." dl_homepage='$homepage',"
		." dl_mtime='$now'"
		." WHERE dl_id='$pdp_did' $pdp_user_access");
	if($pdp_dl['dl_status']==PDP_PRO_ON && !iPDP_ADMIN) {
		$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
			." SET dl_status='".PDP_PRO_OFF."'"
			." WHERE dl_id='$pdp_did' $pdp_user_access");
	}

	pdp_log_event($pdp_dl['dl_status']==PDP_PRO_NEW
		? PDP_EV_NEW : PDP_EV_DESC, 0);

	if($ok) {
		if($pdp_dl['dl_status']==PDP_PRO_NEW) {
			fallback("edit_pics.php?did=$pdp_did");
		}
		fallback(FUSION_SELF."?did=$pdp_did&errno=0");
	}
}


/*
 * CREATE
 */
$all_cats = array();

$query_id = dbquery("SELECT  cat_name, top_cat, cat_id, cat_access"
	." FROM ".DB_PREFIX."pdp_cats"
	." ORDER BY top_cat, cat_name ASC");
while($data = dbarray($query_id)) {
	$all_cats[$data['cat_id']] = array(
		"name" => $data['cat_name'],
		"parentcat" => $data['top_cat'],
		"access" => $data['cat_access'],
	);
}
function pdp_tmp_show_cat($parentid, $cat_array, $level, $prev, $sel_this) {
	$retval = "";
	foreach($cat_array as $myid => $thiscat) {
		if(!pdp_check_access($thiscat['access'])) {
			continue;
		}
		if($myid==$parentid) {
			$retval .= "<option value='$myid'"
				.($sel_this==$myid ? " selected" : "")
				.">$prev"
				.$thiscat['name']."</option>";
//			$prev .= $thiscat['name']." -> ";
			$prev .= "&nbsp;&nbsp;&nbsp;&nbsp;";
		} elseif($thiscat['parentcat']==$parentid) {
			$retval .= pdp_tmp_show_cat($myid, $cat_array,
				$level+1, $prev, $sel_this);
		}
	}
	return $retval;
}

$sel_cats = pdp_tmp_show_cat(0, $all_cats, 0, "",
	isset($pdp_dl) ? $pdp_dl['cat_id'] : 0);
if(empty($sel_cats)) {
	fallback("error.php?errno=".PDP_ECATS);
}



/*
 * GUI
 */
if(!isset($pdp_did)) {
	pdp_upload_step(1);
	$button = $locale['PDP044']." 2";
	$caption = $locale['PDP103'];
} else {
	$button = $locale['PDP010'];
	$caption = $locale['PDP102'];
}

opentable($caption);
if(isset($pdp_did)) {
	echo $pdp_edit_menu;
}
if(isset($_GET['errno'])) {
	pdp_process_errno($_GET['errno']);
}


if(isset($pdp_did)) {
	$name = $pdp_dl['dl_name'];
	$homepage = $pdp_dl['dl_homepage'];
	$desc = $pdp_dl['dl_desc'];
	$copy = $pdp_dl['dl_copyright'];
	$cat_id = $pdp_dl['cat_id'];
	$li_id = $pdp_dl['license_id'];
	$li_ok = ($pdp_dl['lizenz_okay']=="Y" ? "checked" : "" );
	$li_pa = ($pdp_dl['lizenz_packet']=="Y" ? "checked" : "");
	$li_url = $pdp_dl['lizenz_url'];

} else {
	$name = "";
	$homepage = "";
	$desc = "";
	$copy = "Copyright (C) ".$userdata['user_name']." ".date("Y");
	unset($cat_id, $li_id);
	$li_url = "";
	$li_ok = "";
	$li_pa = "";
}


$query_id = dbquery("SELECT license_id, license_name"
	." FROM ".DB_PREFIX."pdp_licenses");
$sel_licenses = "<option value='0'>".$locale['PDP101']."</option>\n";
while($data = dbarray($query_id)) {
	$sel_licenses .= "<option value='".$data['license_id']."'"
		.(isset($li_id)&&$li_id==$data['license_id'] ? " selected" : "")
		.">".$data['license_name']
		."</option>\n";
}


$action = FUSION_SELF;
if(isset($did)) {
	$action .= "?did=$did";
}
echo "<form action='$action' method='POST' name='inputform'"
	." onSubmit='return verify(this);'>
<table width='100%' cellspacing='1' class='tbl-border'>
<tr>
	<td class='tbl2'>".$locale['PDP002'].": *</td>
	<td class='tbl1'><input type='text' value='$name' size='50'"
		." maxlength='200' class='textbox' name='name'></td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP012']." *</td>
	<td class='tbl1'><select size='1' name='cat' class='textbox'>"
		."<option value='0'>".$locale['PDP033']."</option>"
		.$sel_cats."</select></td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP020'].":</td>
	<td class='tbl1'><input type='text' value='$homepage' size='50'"
		." maxlength='200' style='width:100%;'"
		." class='textbox' name='homepage'><span class='small2'>"
		.$locale['PDP216']."</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP025'].":</td>
	<td class='tbl1'><textarea rows='8' class='textbox'"
		." name='desc' style='width:100%;'>$desc</textarea><br>"
		.pdp_get_bb_smileys("desc", "0", false)."</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP104']."</td>
	<td class='tbl1'><input type='text' value='$copy' size='50'"
		." maxlength='255' style='width:100%;'"
		." class='textbox' name='copyright'></td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP105'].":</td>
	<td class='tbl1'><select size='1' name='license_id' class='textbox'>"
		.$sel_licenses."</select><br>
	<input type='checkbox' name='lizenz_okay' $li_ok> "
		.$locale['PDP106']."<br>
	".$locale['PDP107'].": <input type='text' value='$li_url'"
		." maxlength='255' size='60' class='textbox' name='lizenz_url'>
	<br>
	<input type='checkbox' name='lizenz_packet' $li_pa> "
		.$locale['PDP030']."<br>
	</td>
</tr>
<tr>
	<td colspan='2' class='tbl2' align='center'><input type='submit'"
		." class='button' value='$button' name='save'></td>
</tr>
</table>\n";

closetable();

require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
